Package org.codehaus.groovy.transform

# Record Class TupleConstructorASTTransformation.SelectedTupleProperties

java.lang.Object
java.lang.Record
org.codehaus.groovy.transform.TupleConstructorASTTransformation.SelectedTupleProperties

Enclosing class:
  TupleConstructorASTTransformation

public static record TupleConstructorASTTransformation.SelectedTupleProperties(List<PropertyNode> superList, List<PropertyNode> list, List<PropertyNode> ordered) extends Record
Result of `TupleConstructorASTTransformation.selectTupleProperties(org.codehaus.groovy.transform.AbstractASTTransformation, org.codehaus.groovy.ast.ClassNode, org.codehaus.groovy.ast.AnnotationNode)`: the super-class properties and self properties that pass the annotation's filters (includes / excludes / allNames / includeProperties / includeFields / includeSuperProperties / includeSuperFields / allProperties).

`superList` and `list` are in source-declaration order (with super first), suitable for body iteration that needs to know super vs. self membership. `ordered` is the constructor parameter order — concatenation of super + self with the `includes`-attribute reordering applied if `includes` is non-null.

Both the full transform's `TupleConstructorASTTransformation.createConstructor(AbstractASTTransformation, AnnotationNode, ClassNode, boolean, boolean, boolean, boolean, List, List, boolean, boolean, SourceUnit, PropertyHandler, ClosureExpression, ClosureExpression)` and `TupleConstructorASTStubber` consume the same selection so the joint-compilation stub's constructor signature is a strict subset of the runtime's, never a superset.

Since:
  6.0.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SelectedTupleProperties(List<PropertyNode> superList, List<PropertyNode> list, List<PropertyNode> ordered)`
  Creates an instance of a `SelectedTupleProperties` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `List<PropertyNode>`
  `list()`
  Returns the value of the `list` record component.
  `List<PropertyNode>`
  `ordered()`
  Returns the value of the `ordered` record component.
  `List<PropertyNode>`
  `superList()`
  Returns the value of the `superList` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### SelectedTupleProperties

    public SelectedTupleProperties(List<PropertyNode> superList, List<PropertyNode> list, List<PropertyNode> ordered)
    Creates an instance of a `SelectedTupleProperties` record class.
    Parameters:
      `superList` - the value for the `superList` record component
      `list` - the value for the `list` record component
      `ordered` - the value for the `ordered` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### superList

    public List<PropertyNode> superList()
    Returns the value of the `superList` record component.
    Returns:
      the value of the `superList` record component

  - ### list

    public List<PropertyNode> list()
    Returns the value of the `list` record component.
    Returns:
      the value of the `list` record component

  - ### ordered

    public List<PropertyNode> ordered()
    Returns the value of the `ordered` record component.
    Returns:
      the value of the `ordered` record component